"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing_extensions import Annotated, TypedDict


class PendlePositionChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class PendlePositionRequestTypedDict(TypedDict):
    chain: PendlePositionChain
    r"""The chain to use."""
    user_address: str
    r"""The user address of the desired position."""
    market_address: str
    r"""The market address of the desired position."""


class PendlePositionRequest(BaseModel):
    chain: Annotated[
        PendlePositionChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = PendlePositionChain.ETHEREUM_MAINNET
    r"""The chain to use."""

    user_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xa829B388A3DF7f581cE957a95edbe419dd146d1B"
    r"""The user address of the desired position."""

    market_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0xc374f7ec85f8c7de3207a10bb1978ba104bda3b2"
    r"""The market address of the desired position."""
